<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bonusgroupstrategyaccount_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="isDefault", slot-scope="{row}">
        <el-tag v-if="row.isDefault === 1" type="success">是</el-tag>
        <el-tag v-if="row.isDefault === 0" type="info">否</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bonus/bonusgroupstrategyaccount";
  import {mapGetters} from "vuex";

  export default {
    props:{
      bonusSceneId: null,
      bonusGroupId: null,
      bonusGroupStrategyId: null
    },
    data() {
        var validateRate = (rule, value, callback)=>{
            if (value === '') {
                callback(new Error('请输入分润比例'));
            } else {
                let pattern = /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/;
                if(pattern.test(value)){
                    callback();
                }else{
                    callback(new Error('请正确填写分润比例,可保留两位小数。总比例是100%'));
                }
                callback();
            }
        };
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          // dialogDirection:'rtl',
          // dialogType:'drawer',
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "业务场景",
              prop: "bonusSceneId",
              type: "select",
              rules: [{
                required: true,
                message: "请输入业务场景ID",
                trigger: "blur"
              }],
              value: this.bonusSceneId,
              cascaderItem: ['bonusGroupId', 'bonusGroupStrategyId', "bonusGroupAccountId"],
              dicUrl: "/api/cyzh-bonus-scene/bonusscene/listBonusScene?size=10",
              props:{
                label: "name",
                value: "id"
              },
            },
            {
              label: "分润商户",
              prop: "bonusGroupId",
              type: "select",
              rules: [{
                required: true,
                message: "请输入分润商户组ID",
                trigger: "blur"
              }],
                value: this.bonusGroupId,
              dicUrl: "/api/cyzh-bonus-group/bonusgroup/listBonusGroup?bonusSceneId={{bonusSceneId}}&size=500",
              props:{
                label: "name",
                value: "id"
              },
            },
            {
              label: "分润策略",
              prop: "bonusGroupStrategyId",
              type: "select",
              rules: [{
                required: true,
                message: "请输入分润组策略ID",
                trigger: "blur"
              }],
              value: this.bonusGroupStrategyId,
              dicUrl: "/api/cyzh-bonus-group-strategy/bonusgroupstrategy/listBonusGroupStrategy?bonusSceneId={{bonusSceneId}}&bonusGroupId={{bonusGroupId}}&size=500",
              props:{
                label: "name",
                value: "id"
              },
            },
            {
              label: "分润账户",
              prop: "bonusGroupAccountId",
              type: "select",
              hide: true,
              viewDisplay:false,
              dicUrl: "/api/cyzh-bonus-group-account/bonusgroupaccount/listBonusGroupAccount?bonusSceneId={{bonusSceneId}}&bonusGroupId={{bonusGroupId}}&size=500",
              props:{
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择分润组账户",
                trigger: "blur"
              }]
            },
            {
              label: "账户名称",
              prop: "accountName",
              addDisplay:false,
              editDisplay:false,
            },
            {
              label: "银行账号",
              prop: "accountNo",
              addDisplay:false,
              editDisplay:false,
            },
            {
              label: "开户行",
              prop: "bankName",
              addDisplay:false,
              editDisplay:false,
            },
            {
              label: "是否平台账户",
              prop: "isDefault",
              labelWidth: 110,
              type: "select",
              slot: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入是否是默认账户",
                trigger: "blur"
              }],
              dicData:[
                {
                  label:"是",
                  value:1
                },
                {
                  label:"否",
                  value: 0
                },
              ],
            },
            {
              label: "分成比例（%）",
              prop: "rate",
              labelWidth: 130,
              rules: [{
                required: true,
                message: "请输入分成比例（单位百分比）总比例是100%",
                trigger: "blur",
                validator: validateRate
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bonusgroupstrategyaccount_add, false),
          viewBtn: this.vaildData(this.permission.bonusgroupstrategyaccount_view, false),
          delBtn: this.vaildData(this.permission.bonusgroupstrategyaccount_delete, false),
          editBtn: this.vaildData(this.permission.bonusgroupstrategyaccount_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        params["bonusSceneId"] = this.bonusSceneId;
        params["bonusGroupId"] = this.bonusGroupId;
        params["bonusGroupStrategyId"] = this.bonusGroupStrategyId;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
